# Copyright 2015 Canonical Ltd.  This software is licensed under the
# GNU Affero General Public License version 3 (see the file LICENSE).

from __future__ import unicode_literals

import os

import yaml


class RutabagaConfig(object):
    """Return configuration from environment or defaults."""

    def get(self, key):
        secret_path = os.path.join(os.path.sep, 'srv',
                                   'rutabaga', '.admin-secret')
        if key == 'admin_api_secret' and os.path.isfile(secret_path):
            with open(secret_path, 'r') as f:
                return f.readline().strip()

        config = os.path.join(os.path.dirname(os.path.dirname(__file__)),
                              'config.yaml')
        with open(config) as config_file:
            defaults = yaml.load(config_file)
            return (os.getenv(key.upper()) or defaults.get(key.lower()) or '')
