#!/srv/rutabaga/code/env/bin/python3

import sys

from requests import (
    codes,
    Session,
    )
from requests.adapters import HTTPAdapter
from requests.exceptions import (
    ConnectionError,
    Timeout,
    )


AUTH_WS_URL = 'http://localhost:8080/validate'

# squid 'debug_options ALL,1 82,9 84,9' can be potentially
# useful for debugging this helper.


def read_stdin():
    line = sys.stdin.readline()
    validate(line)


def validate(squid_stdin):
    data = squid_stdin.split()
    if len(data) != 2:
        # squid can potentially return channel_id in position 0
        # if concurrency is enabled.
        raise IOError

    username = data[0]  # username
    secret = data[1]  # password

    s = Session()
    s.mount('http://', HTTPAdapter(max_retries=5))

    try:
        r = s.post(AUTH_WS_URL, json={'secret': secret,
                                      'username': username})
    except (ConnectionError, Timeout):
        # squid 3.4 implements a more informative helper failure code
        # 'BH'. If we upgrade, consider using.
        # http://wiki.squid-cache.org/Features/AddonHelpers#Basic_Scheme
        sys.exit(1)

    if r.status_code == codes.ok and r.json()['username'] == username:
        sys.stdout.write('OK\n')
    else:
        sys.stderr.write('ERR\n')


if __name__ == '__main__':
    read_stdin()
