#!/usr/bin/env python3

# Copyright 2015 Canonical Ltd.  This software is licensed under the
# GNU Affero General Public License version 3 (see the file LICENSE).

import os
from setuptools import (
    find_packages,
    setup,
    )

here = os.path.abspath(os.path.dirname(__file__))

with open(os.path.join(here, 'README.rst')) as f:
    README = f.read()

requires = [
    'cornice',
    'Paste',
    'PyYAML',
    'waitress',
    ]
test_requires = [
    'fixtures',
    'flake8',
    'testtools',
    'webtest',
    ]
deploy_requires = [
    'envdir',
    'gunicorn',
    ]

setup(
    name='rutabaga',
    version='0.1',
    packages=[
        'rutabaga.%s' % package for package in
        find_packages('rutabaga', exclude=['*.tests', 'tests'])],
    include_package_data=True,
    zip_safe=False,
    maintainer='LAZR Developers',
    maintainer_email='lazr-developers@lists.launchpad.net',
    description='rutabaga',
    long_description=README,
    license='AGPL v3',
    url='https://launchpad.net/rutabaga',
    download_url='https://launchpad.net/rutabaga/+download',
    classifiers=[
        'Development Status :: 4 - Beta',
        'Intended Audience :: Developers',
        'License :: OSI Approved :: GNU Affero General Public License v3',
        'Operating System :: OS Independent',
        'Programming Language :: Python',
    ],
    data_files=[('.', ['config.yaml'])],
    keywords="web services, squid",
    install_requires=requires,
    tests_require=test_requires,
    extras_require=dict(
        test=test_requires,
        deploy=deploy_requires),
    test_suite='rutabaga',
    entry_points="""\
      [paste.app_factory]
      main = rutabaga:main
      """,
    paster_plugins=['pyramid']
    )
